;----------------------;
;    ET-LDB 2 BOARD    ;
;     for ET-BOARD     ;
;----------------------;
         CPU "Z80.TBL"
         HOF "INT8"

         ORG 2000H
COUNT10: EQU 3100H  ; Ѻӹǹѡ(10ѡ)
COUNT11: EQU 3101H  ; Ѻӹǹѡ㹡
                    ; ͹(11ѡ)
COUNT8:  EQU 3102H  ; Ѻӹǹ(8)
LOOP:    EQU 3103H  ; ˹㹡
                    ; ӹǹٻͧ scan
LOOPCH:  EQU 3104H  ; Ǩͺҵѡö١͹
                    ; ú 8 Եѧ
ENDCH:   EQU 3105H  ; ǨͺҾشѧ
C_ENDCH: EQU 3106H  ; Ǩͺ;ش
                    ; ѡö١͹令ú 10 ѡѧ
BUFFER:  EQU 3000H  ; ˹鹢ͧ display buffer
                    ; 5ѡ(3000H-304FH)
DISPY:   EQU 3050H  ; ˹鹢ͧ display buffer
                    ; ѡ 6(3050H-3057H)
NUMLP:   EQU 03H    ; ӹǹٻͧ scan
PORTA:   EQU 20H    ; port A ͧ 8255  ET-BOARD
PORTB:   EQU 21H    ; port B ͧ 8255  ET-BOARD
PORTC:   EQU 22H    ; port C ͧ 8255  ET-BOARD
CTPORT:  EQU 23H    ; port control ͧ 8255  ET-BOARD

         CALL DELAY
         LD  A,80H
         OUT (CTPORT),A
         OUT (PORTB),A     ; OFF SCAN
         CALL DELAY
         ;-----------
         CALL INITIAL
         ;-----------
         CALL CLEAR
         ;-----------
         LD IY,DTBF
         CALL DECODE
         CALL NEW

;-----------------------
MAIN:    LD D,00H
         LD E,00H
         LD IX,BUFFER
MMM:     PUSH IX
         ;---------
         CALL OPEN
         ;---------
         CALL CLOSE
         ;---------
         POP IX
         INC IX
         CALL DEC8
         JR NZ,MMM
         LD A,08H
         LD (COUNT8),A

         LD A,(LOOP)
         DEC A
         LD (LOOP),A
         JR NZ,MAIN     ; Ǩͺӹǹͺͧ scan
         LD A,NUMLP
         LD (LOOP),A
;-----------------------

         LD A,(LOOPCH)
         DEC A
         LD (LOOPCH),A  ; Ǩͺҵѡö١͹
         JR NZ,RSDATA   ; 令ú 8 Եѧ
         LD A,08H
         LD (LOOPCH),A

         LD A,(ENDCH)
         CP 01H
         JR NZ,CODE1    ; Ǩͺش(1A)
         LD A,(C_ENDCH)
         DEC A
         LD (C_ENDCH),A
         CP 00H         ; Ǩͺѡõش
         JR NZ,DATA00   ; Ҷ١͹令ú 5 ѡѧ
         LD A,0AH
         LD (C_ENDCH),A
         XOR A
         LD (ENDCH),A
         LD IY,DTBF
         JR CODE1

DATA00:  LD HL,TABLE
         JR CODE2
CODE1:   CALL DECODE
CODE2:   CALL NEW

RSDATA:  ;----------
         CALL ROTATE
         ;----------
         CALL SHIFT
         ;----------
         JP MAIN

;------------------------; ҵ˹鹢ͧ͹
; DECODE  ASCII -> TABLE ; ѡ¹ data 
;------------------------; ͧѡèҡ ASCII
DECODE:  LD HL,TABLE     ; 1 亵 繿͹ͧѡ
         LD BC,0008H     ; Ҵ 8 亵 ͷй data
         LD A,(IY+0)     ; Ҵ 8 亵ʴ
         CP 1AH
         JR NZ,D_CODE

         LD A,(ENDCH)
         SETT 0,A
         LD (ENDCH),A
         JR RETURN

D_CODE:  ADD HL,BC
         DEC A
         JR NZ,D_CODE
         DEC H
         INC IY
RETURN:  RET

;------------------------; ӡ data 㹵˹
;       ON LED           ; display buffer  5 ѡ 
;------------------------; ͡ѧ LED
OPEN:    PUSH DE
A1:      LD A,D
         OR 0F0H
         OUT (PORTB),A
         LD A,(IX+0)
         OUT (PORTA),A
         LD A,0FFH
         OUT (PORTB),A
         INC D
         CALL IX8
         CALL DEC5
         JR NZ,A1
         LD A,0AH
         LD (COUNT10),A
         POP DE

         LD A,D
         AND 0F0H
         OUT (PORTB),A
         ADD A,10H
         LD D,A
         CALL DELAY
         RET

;------------------------; ӡ clear data
;       OFF LED          ; ѧ LED
;------------------------;
CLOSE:   PUSH DE
A2:      LD A,E
         OR 0F0H
         OUT (PORTB),A
         LD A,00H
         OUT (PORTA),A
         LD A,0FFH
         OUT (PORTB),A
         INC E
         CALL DEC5
         JR NZ,A2
         LD A,0AH
         LD (COUNT10),A
         POP DE

         LD A,E
         AND 0F0H
         OUT (PORTB),A
         ADD A,10H
         LD E,A
         CALL DELAY
         RET

;------------------------; ӡعŷ㹵˹
;       ROTATE DATA      ; display buffer  6 ѡ
;------------------------;
ROTATE:  LD IX,BUFFER
R1:      PUSH IX
R2:      LD A,(IX+0)
         RLCA
         LD (IX+0),A
         CALL IX8
         CALL DEC6
         JR NZ,R2
         LD A,0BH
         LD (COUNT11),A
         POP IX

         INC IX
         CALL DEC8
         JR NZ,R1
         LD A,08H
         LD (COUNT8),A
         RET

;------------------------; ӡ͹ŷ㹵˹
;        SHIFT DATA      ; display buffer  6 ѡ
;------------------------; 价ҧ 1 Ե
SHIFT:   LD IX,BUFFER
S1:      PUSH IX
S2:      RES 0,(IX+0)
         LD A,(IX+8)
         AND 01H
         ADD A,(IX+0)
         LD (IX+0),A
         CALL IX8
         CALL DEC5
         JR NZ,S2
         LD A,0AH
         LD (COUNT10),A
         POP IX

         INC IX
         CALL DEC8
         JR NZ,S1
         LD A,08H
         LD (COUNT8),A
         RET

;------------------------;
;    INITIAL VALUE       ; ˹鹵ҧ
;------------------------;
INITIAL: XOR A
         LD (ENDCH),A
         LD A,0AH
         LD (COUNT10),A
         LD (C_ENDCH),A
         LD A,0BH
         LD (COUNT11),A
         LD A,NUMLP
         LD (LOOP),A
         LD A,08H
         LD (COUNT8),A
         LD (LOOPCH),A
         RET

;------------------------; ӡ clear data 㹵˹
;       CLEAR DATA       ; display buffer  5 ѡ
;------------------------; դ "0"
CLEAR:   LD B,50H
         LD IX,BUFFER
         LD A,00H
CCC:     LD (IX+0),A
         INC IX
         DJNZ CCC
         RET

;------------------------;  data ͧѡõ 
;     NEW CHARACTER      ; ͡ʴ㹵˹
;------------------------; display buffer ѡ 6
NEW:     PUSH HL
         LD IX,DISPY
         LD B,08H
X1:      LD A,(HL)
         LD (IX+0),A
         INC HL
         INC IX
         DJNZ X1
         POP HL
         RET

;------------------------;
;       DALAY            ;
;------------------------;
DELAY:   PUSH DE
         LD E,80H
DDD:     DEC E
         JR NZ,DDD
         POP DE
         RET


IX8:     LD BC,0008H      ;  IX  8
         ADD IX,BC
         RET

DEC5:    LD A,(COUNT10)   ; Ŵ count10 ŧ 1
         DEC A
         LD (COUNT10),A
         RET

DEC6:    LD A,(COUNT11)   ; Ŵ count11 ŧ 1
         DEC A
         LD (COUNT11),A
         RET

DEC8:    LD A,(COUNT8)    ; Ŵ count8 ŧ 1
         DEC A
         LD (COUNT8),A
         RET

;------------------------------------------------
;      ͹ѡ ҡ ASCII 20H-7FH
;------------------------------------------------

TABLE:   DFB 00H,00H,00H,00H
         DFB 00H,00H,00H,00H    ;

         DFB 10H,10H,10H,10H
         DFB 00H,00H,10H,00H    ; !

         DFB 28H,28H,28H,00H
         DFB 00H,00H,00H,00H    ; "

         DFB 28H,28H,7CH,28H
         DFB 7CH,28H,28H,00H    ; #

         DFB 10H,3CH,50H,38H
         DFB 14H,78H,10H,00H    ; $

         DFB 60H,64H,08H,10H
         DFB 20H,4CH,0CH,00H    ; %

         DFB 30H,48H,50H,20H
         DFB 54H,48H,34H,00H    ; &

         DFB 30H,10H,20H,00H
         DFB 00H,00H,00H,00H    ; '

         DFB 08H,10H,20H,20H
         DFB 20H,10H,08H,00H    ; (

         DFB 20H,10H,08H,08H
         DFB 08H,10H,20H,00H    ; )

         DFB 00H,10H,54H,38H
         DFB 54H,10H,00H,00H    ; *

         DFB 00H,10H,10H,7CH
         DFB 10H,10H,00H,00H    ; +

         DFB 00H,00H,00H,00H
         DFB 30H,10H,20H,00H    ; ,

         DFB 00H,00H,00H,7CH
         DFB 00H,00H,00H,00H    ; -

         DFB 00H,00H,00H,00H
         DFB 00H,30H,30H,00H    ; .

         DFB 00H,04H,08H,10H
         DFB 20H,40H,00H,00H    ; /

         DFB 38H,44H,4CH,54H
         DFB 64H,44H,38H,00H    ; 0

         DFB 10H,30H,10H,10H
         DFB 10H,10H,38H,00H    ; 1

         DFB 38H,44H,04H,08H
         DFB 10H,20H,7CH,00H    ; 2

         DFB 7CH,08H,10H,08H
         DFB 04H,44H,38H,00H    ; 3

         DFB 08H,18H,28H,48H
         DFB 7CH,08H,08H,00H    ; 4

         DFB 7CH,40H,78H,04H
         DFB 04H,44H,38H,00H    ; 5

         DFB 18H,20H,40H,78H
         DFB 44H,44H,38H,00H    ; 6

         DFB 7CH,04H,08H,10H
         DFB 20H,20H,20H,00H    ; 7

         DFB 38H,44H,44H,38H
         DFB 44H,44H,38H,00H    ; 8

         DFB 38H,44H,44H,3CH
         DFB 04H,08H,30H,00H    ; 9

         DFB 00H,30H,30H,00H
         DFB 30H,30H,00H,00H    ; :

         DFB 00H,30H,30H,00H
         DFB 30H,10H,20H,00H    ; ;

         DFB 08H,10H,20H,40H
         DFB 20H,10H,08H,00H    ; <

         DFB 00H,00H,7CH,00H
         DFB 7CH,00H,00H,00H    ; =

         DFB 20H,10H,08H,04H
         DFB 08H,10H,20H,00H    ; >

         DFB 38H,44H,04H,08H
         DFB 10H,00H,10H,00H    ; ?

         DFB 38H,44H,04H,34H
         DFB 54H,54H,38H,00H    ; @

         DFB 38H,44H,44H,44H
         DFB 7CH,44H,44H,00H    ; A

         DFB 78H,44H,44H,78H
         DFB 44H,44H,78H,00H    ; B

         DFB 38H,44H,40H,40H
         DFB 40H,44H,38H,00H    ; C

         DFB 70H,48H,44H,44H
         DFB 44H,48H,70H,00H    ; D

         DFB 7CH,40H,40H,78H
         DFB 40H,40H,7CH,00H    ; E

         DFB 7CH,40H,40H,78H
         DFB 40H,40H,40H,00H    ; F

         DFB 38H,44H,40H,5CH
         DFB 44H,44H,3CH,00H    ; G

         DFB 44H,44H,44H,7CH
         DFB 44H,44H,44H,00H    ; H

         DFB 38H,10H,10H,10H
         DFB 10H,10H,38H,00H    ; I

         DFB 1CH,08H,08H,08H
         DFB 08H,48H,30H,00H    ; J

         DFB 44H,48H,50H,60H
         DFB 50H,48H,44H,00H    ; K

         DFB 40H,40H,40H,40H
         DFB 40H,40H,7CH,00H    ; L

         DFB 44H,6CH,54H,54H
         DFB 44H,44H,44H,00H    ; M

         DFB 44H,44H,64H,54H
         DFB 4CH,44H,44H,00H    ; N

         DFB 38H,44H,44H,44H
         DFB 44H,44H,38H,00H    ; O

         DFB 78H,44H,44H,78H
         DFB 40H,40H,40H,00H    ; P

         DFB 38H,44H,44H,44H
         DFB 54H,48H,34H,00H    ; Q

         DFB 78H,44H,44H,78H
         DFB 50H,48H,44H,00H    ; R

         DFB 3CH,40H,40H,38H
         DFB 04H,04H,78H,00H    ; S

         DFB 7CH,10H,10H,10H
         DFB 10H,10H,10H,00H    ; T

         DFB 44H,44H,44H,44H
         DFB 44H,44H,38H,00H    ; U

         DFB 44H,44H,44H,44H
         DFB 44H,28H,10H,00H    ; V

         DFB 44H,44H,44H,54H
         DFB 54H,54H,28H,00H    ; W

         DFB 44H,44H,28H,10H
         DFB 28H,44H,44H,00H    ; X

         DFB 44H,44H,44H,28H
         DFB 10H,10H,10H,00H    ; Y

         DFB 7CH,04H,08H,10H
         DFB 20H,40H,7CH,00H    ; Z

         DFB 38H,20H,20H,20H
         DFB 20H,20H,38H,00H    ; [

         DFB 40H,20H,10H,08H
         DFB 04H,02H,01H,00H    ; \

         DFB 38H,08H,08H,08H
         DFB 08H,08H,38H,00H    ; ]

         DFB 10H,28H,44H,00H
         DFB 00H,00H,00H,00H    ; ^

         DFB 00H,00H,00H,00H
         DFB 00H,00H,7CH,00H    ; _

         DFB 20H,10H,08H,00H
         DFB 00H,00H,00H,00H    ;`

         DFB 00H,00H,38H,08H
         DFB 38H,48H,34H,00H    ; a

         DFB 40H,40H,58H,64H
         DFB 44H,44H,78H,00H    ; b

         DFB 00H,00H,3CH,40H
         DFB 40H,40H,3CH,00H    ; c

         DFB 04H,04H,34H,4CH
         DFB 44H,44H,3CH,00H    ; d

         DFB 00H,00H,38H,44H
         DFB 78H,40H,38H,00H    ; e

         DFB 18H,24H,20H,70H
         DFB 20H,20H,20H,00H    ; f

         DFB 00H,00H,38H,44H
         DFB 44H,3CH,04H,38H    ; g

         DFB 40H,40H,58H,64H
         DFB 44H,44H,44H,00H    ; h

         DFB 10H,00H,30H,10H
         DFB 10H,10H,38H,00H    ; i

         DFB 00H,08H,00H,08H
         DFB 08H,28H,10H,00H    ; j

         DFB 40H,40H,48H,50H
         DFB 60H,50H,48H,00H    ; k

         DFB 30H,10H,10H,10H
         DFB 10H,10H,18H,00H    ; l

         DFB 00H,00H,68H,54H
         DFB 54H,54H,44H,00H    ; m

         DFB 00H,00H,58H,24H
         DFB 24H,24H,24H,00H    ; n

         DFB 00H,00H,38H,44H
         DFB 44H,44H,38H,00H    ; o

         DFB 00H,00H,70H,48H
         DFB 48H,70H,40H,40H    ; p

         DFB 00H,00H,38H,48H
         DFB 48H,38H,08H,08H    ; q

         DFB 00H,00H,58H,64H
         DFB 40H,40H,40H,00H    ; r

         DFB 00H,00H,38H,40H
         DFB 38H,04H,78H,00H    ; s

         DFB 20H,20H,78H,20H
         DFB 20H,24H,18H,00H    ; t

         DFB 00H,00H,48H,48H
         DFB 48H,48H,34H,00H    ; u

         DFB 00H,00H,44H,44H
         DFB 28H,28H,10H,00H    ; v

         DFB 00H,00H,44H,44H
         DFB 54H,54H,28H,00H    ; w

         DFB 00H,00H,44H,28H
         DFB 10H,28H,44H,00H    ; x

         DFB 00H,00H,48H,48H
         DFB 48H,38H,08H,70H    ; y

         DFB 00H,00H,7CH,08H
         DFB 10H,20H,7CH,00H    ; z

         DFB 08H,10H,10H,20H
         DFB 10H,10H,08H,00H    ; {

         DFB 18H,18H,18H,18H
         DFB 18H,18H,18H,00H    ; |

         DFB 20H,10H,10H,08H
         DFB 10H,10H,20H,00H    ; }

         DFB 00H,00H,00H,32H
         DFB 4CH,00H,00H,00H    ; ~

         DFB 0FFH,0FFH,0FFH,0FFH
         DFB 0FFH,0FFH,0FFH,0FFH


;------------------------------------------------------
;       DATA й͡ʴ  ASCII
;------------------------------------------------------

         ORG 2500H
DTBF:    DFB 45H,54H,2DH,4CH    ;ET-L
         DFB 44H,42H,20H,22H    ;DB "
         DFB 4CH,49H,47H,48H    ;LIGH
         DFB 54H,20H,44H,49H    ;T DI
         DFB 53H,50H,4CH,41H    ;SPLA
         DFB 59H,20H,42H,4FH    ;Y BO
         DFB 41H,52H,44H,22H    ;ARD"
         DFB 1AH
         END

































































































































































































































































































































































































































































































































































































































































































































